/***************************************************************************
 *   Copyright (C) 2007-2009 by Thomas Thelliez <admin.kontrol@gmail.com>  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as               *
 *   published by the Free Software Foundation; either version 2.0 of      *
 *   the License, or (at your option) any later version.                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public             *
 *   License along with this program; if not, write to                     *
 *   the Free Software Foundation, Inc.,                                   *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA          *
 ***************************************************************************/

#ifndef CLIENTMAINWIDGET_H
#define CLIENTMAINWIDGET_H

#include <QMainWindow>
#include "main/common/AboutDialog.h"
#include "ClientShell.h"
#include "datastore/XmlDataStore.h"

class ClientMainWidget : public QMainWindow
{
    Q_OBJECT

public:
    ClientMainWidget();
    AboutDialog *aboutDialog;
    ClientShell *clientShell;
private slots:
    void displayAbout();
     void iconActivated(QSystemTrayIcon::ActivationReason reason);
     void showMessage();
     void messageClicked();
     void startClient();
	 void switchMode();

protected:
     void closeEvent(QCloseEvent *event);

private:
     void createActions();
     void createTrayIcon();
     QAction *minimizeAction;
     QAction *restoreAction;
     QAction *quitAction;

     QSystemTrayIcon *trayIcon;
     QMenu *trayIconMenu;

};

#endif
