/***************************************************************************
 *   Copyright (C) 2007-2009 by Thomas Thelliez <admin.kontrol@gmail.com>  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as               *
 *   published by the Free Software Foundation; either version 2.0 of      *
 *   the License, or (at your option) any later version.                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public             *
 *   License along with this program; if not, write to                     *
 *   the Free Software Foundation, Inc.,                                   *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA          *
 ***************************************************************************/

#include "UpdateManager.h"

UpdateManager::UpdateManager()
{
    xmlResultsParser = new XmlResultsParser(this);
}

void UpdateManager::updateManager()
{
    http = new QHttp(this);
    http->setHost("kontrolpack.com");
    http->get("/version.xml");
    connect(http, SIGNAL(done(bool)), this, SLOT(readVersion()));
}

void UpdateManager::readVersion()
{
    QByteArray versionByteArray = http->readAll();
    QString version = xmlResultsParser->getVersion(QString(versionByteArray));
    if (!version.isEmpty())
        if (QString::compare(version, QString(VERSION), Qt::CaseInsensitive) != 0) {
        UpdateDialog *updateDialog = new UpdateDialog(version);
        updateDialog->exec();
    }
}
